*Giuseppe Forte, King's College London

set more off
di as red "cd directory"

use Stata/IPSdataset, replace
drop if year>2015
replace ipsINval=0 if ipsINval==. 

xtset cob year

*Figure 1: frequency of origin-year inflows, by magnitude
preserve
replace ipsINval = ipsINval*1000
replace ipsINval=0 if ipsINval==.
twoway histogram ipsINval if cob!=0, frequency bin(100) ///
ytitle("Yearly Inflow") xtitle("Number of events") horizontal ///
scheme(s1color) fcol(white) lcol(navy)
graph export Figures/zeros.png, as(png) replace
sleep 4000
restore

*Table 1: Migratory inflows by selected region and 4-year period (000’s)
preserve
replace ipsINval=0 if ipsINval==.
{
g a2=(cob==35 | cob==169)
g a8=(cob==59 | cob==70 | cob==97 | cob==115 | cob==121 | cob==164 | cob==185 | cob==186)
g eu=(cob==15| cob==23 | cob==35 | cob==56 | cob==58 | cob==59 | cob==60 | cob==70 | ///
cob==75 | cob==76 | cob==83 | cob==85 | cob==97 | cob==103 | cob==105 | cob==115 | ///
cob==121 | cob==122 | cob==130 |cob==145 | cob==164 | cob==165 | cob==169 | cob==185 | ///
cob==186 | cob==192 | cob==202)
g eunota2a8=(cob==15| cob==23 | cob==56 | cob==58 | cob==60 | ///
cob==75 | cob==76 | cob==83 | cob==85 | cob==103 | cob==105 | ///
cob==122 | cob==130 |cob==145 | cob==165 |cob==192 | cob==202)
g restofeu=(cob==2 | cob==5 | cob==16 | cob==22 | cob==29 ///
| cob==98 | cob==120 | cob==124 | cob==130 | cob==137 | cob==154 ///
| cob==170 | cob==174 | cob==179 | cob==203 | cob==220 | cob==227)
g restofasia=(cob==1 | cob==12 | cob==16 | cob==18 | cob==19 ///
| cob==27 | cob==34 | cob==37 | cob==39 | cob==82 | cob==100 ///
| cob==101 | cob==102 | cob==104 | cob==108 | cob==109 ///
| cob==110 | cob==112 | cob==113 | cob==114 | cob==116 ///
| cob==127 | cob==128 | cob==139 | cob==144 | cob==153 ///
| cob==155 | cob==157 | cob==162 | cob==167 | cob==170 ///
| cob==177 | cob==183 | cob==191 | cob==193 | cob==204 ///
| cob==205 | cob==206 | cob==208 | cob==215 | cob==216 ///
| cob==221 | cob==225 | cob==229 | cob==234 | cob==239)
g china=(cob==47)
g india=(cob==99)
g asia=(cob==1 | cob==12 | cob==16 | cob==18 | cob==19 ///
| cob==27 | cob==34 | cob==37 | cob==39 | cob==82 | cob==100 ///
| cob==101 | cob==102 | cob==104 | cob==108 | cob==109 ///
| cob==110 | cob==112 | cob==113 | cob==114 | cob==116 ///
| cob==127 | cob==128 | cob==139 | cob==144 | cob==153 ///
| cob==155 | cob==157 | cob==162 | cob==167 | cob==170 ///
| cob==177 | cob==183 | cob==191 | cob==193 | cob==204 ///
| cob==205 | cob==206 | cob==208 | cob==215 | cob==216 ///
| cob==221 | cob==225 | cob==229 | cob==234 | cob==239 ///
| cob==47 | cob==99) 
g usa=(cob==222)
g canada=(cob==41)
g restofname=(cob==9 | cob==17 | cob==20 | cob==24 | cob==55 ///
| cob==57 | cob==62 | cob==63 | cob==67 | cob==87 | cob==89 ///
| cob==93 | cob==95 | cob==107 | cob==135 | cob==148 | cob==158 ///
| cob==195 | cob==196 | cob==198 | cob==213 | cob==7 | cob==13 ///
| cob==26 | cob==230 | cob==43 | cob==86 | cob==88 | cob==131 ///
| cob==140 | cob==166 | cob==172 | cob==269 | cob==197 | cob==184 ///
| cob==217 | cob==231)
g name=(cob==9 | cob==17 | cob==20 | cob==24 | cob==55 ///
| cob==57 | cob==62 | cob==63 | cob==67 | cob==87 | cob==89 ///
| cob==93 | cob==95 | cob==107 | cob==135 | cob==148 | cob==158 ///
| cob==195 | cob==196 | cob==198 | cob==213 | cob==7 | cob==13 ///
| cob==26 | cob==230 | cob==43 | cob==86 | cob==88 | cob==131 ///
| cob==140 | cob==166 | cob==172 | cob==269 | cob==197 | cob==184 ///
| cob==217 | cob==231 | cob==41 | cob==222)
g same=(cob==11 | cob==28 | cob==32 | cob==46 | cob==50 | cob==65 ///
| cob==92 | cob==160 | cob==161 | cob==200 | cob==223 | cob==228 ///
| cob==72 | cob==77 | cob==190)
g brazil=(cob==32)
g oceania=(cob==14 | cob==74 | cob==136 | cob==147 | cob==159 | cob==173 ///
| cob==287 | cob==211 | cob==218 | cob==226 | cob==4 | cob==54 | cob==78 ///
| cob==146 | cob==151 | cob==152 | cob==163 | cob==210 | cob==232)
g australia=(cob==14)
g y0003=(year==2000|year==2001|year==2002|year==2003)
g y0407=(year==2004|year==2005|year==2006|year==2007)
g y0811=(year==2008|year==2009|year==2010|year==2011)
g y1215=(year==2012|year==2013|year==2014|year==2015)
}
foreach w in a2 a8 eu eunota2a8 restofeu china india asia restofasia usa canada ///
name restofname same brazil oceania australia{

di as red "`w'"
sum ipsINval if `w' & y0003
sum ipsINval if `w' & y0407
sum ipsINval if `w' & y0811
sum ipsINval if `w' & y1215
}
restore


*Table 3: Regression estimates
foreach w in rgdpuk rgdp {
g `w'pp = `w'/pop
}
*
foreach w in pop erate erateuk popuk erateuk rxgbp ipsINval ninoyear ///
WBukgdppc realxr WBGDPpc WBpop WBunemp xr WBukunem{
cap drop l`w'
g l`w'=ln(`w')
}
g lWBukgdppc2 = lWBukgdppc^2 
g lWBGDPpc2 = lWBGDPpc^2 
g lunemratio = lWBunem - lWBukunem

/*
gen y0005 = (year==2000 | year==2001 | year==2002 | year==2003 | year==2004 | year==2005)
gen y0611= (year==2006 | year==2007 | year==2008 | year==2009 | year==2010 | year==2011)
gen y1215 = (year==2012 | year==2013 | year==2014 | year==2015)
local originyear y0005#i.cob y0611#i.cob y1215#i.cob
*/

*Least Squares
xtreg lipsINval lWBukgdppc lWBGDPpc lWBGDPpc2 lWBunemp lWBpop inEU lrealxr if cob!=0 , fe vce(cl cob)
predict xtregresid if e(sample), e
xtcd2 xtregresid 
local cdvalue = round(r(CD), .001)
local cdpvalue = round(r(p), .001)
foreach delete in xtregresid {
cap drop `delete'
}

outreg2 using Output/restricted/Linear, replace ctitle(no Year FE) tex addtext(Year FE, No, CD test, `cdvalue', P-Value, `cdpvalue')
outreg2 using Output/restricted/Total, replace ctitle(Linear FE) tex addtext(Year FE, No, CD test, `cdvalue', P-Value, `cdpvalue')

xtreg lipsINval lWBukgdppc lWBGDPpc lWBGDPpc2 lWBunemp lWBpop inEU lrealxr i.year if cob!=0 , fe vce(cl cob)
predict xtregresid if e(sample), e 
xtcd2 xtregresid 
local cdvalue = round(r(CD), .001)
local cdpvalue = round(r(p), .001)
foreach delete in xtregresid {
cap drop `delete'
}
outreg2 using Output/restricted/Linear, ctitle(Year FE) tex addtext(Year FE, Yes, CD test, `cdvalue', P-Value, `cdpvalue')
outreg2 using Output/restricted/Total, ctitle(Linear FE) tex addtext(Year FE, Yes, CD test, `cdvalue', P-Value, `cdpvalue')

*Poisson (GLM f(poisson))
glm ipsINval lWBukgdppc lWBGDPpc lWBGDPpc2 lWBunemp lWBpop inEU lrealxr i.cob if cob!=0, vce(cl cob) f(poisson)
local clusters = e(N_clust)
predict pearson if e(sample), p
xtcd2 pearson
local cdvalue = round(r(CD), .001)
local cdpvalue = round(r(p), .001)
local pr2 = round(`e(r2_p)',.01)
foreach delete in pearson{
cap drop `delete'
}
outreg2 using Output/restricted/Poisson, ctitle(no Year FE) tex addtext(Year FE, No, CD test, `cdvalue', Number of cob, `clusters', P-Value, `cdpvalue', R-squared, "0`pr2'")
outreg2 using Output/restricted/Total, ctitle(PPML FE) tex addtext(Year FE, No, CD test, `cdvalue', Number of cob, `clusters', P-Value, `cdpvalue', R-squared, "0`pr2'")

glm ipsINval lWBukgdppc lWBGDPpc lWBGDPpc2 lWBunemp lWBpop inEU lrealxr i.cob i.year if cob!=0 , vce(cl cob) f(poisson)
local clusters = e(N_clust)
predict pearson if e(sample), p
xtcd2 pearson
local cdvalue = round(r(CD), .001)
local cdpvalue = round(r(p), .001)
local pr2 = round(`e(r2_p)',.01)
foreach delete in pearson{
cap drop `delete'
}
outreg2 using Output/restricted/Poisson, ctitle(Year FE) tex addtext(Year FE, Yes, CD test, `cdvalue', Number of cob, `clusters', P-Value, `cdpvalue', R-squared, "0`pr2'")
outreg2 using Output/restricted/Total, ctitle(PPML FE) tex addtext(Year FE, Yes, CD test, `cdvalue', Number of cob, `clusters', P-Value, `cdpvalue', R-squared, "0`pr2'")

							
*Annex B: Countries included in analysis
glm ipsINval lWBukgdppc lWBGDPpc lWBGDPpc2 lWBunemp lWBpop inEU lrealxr i.cob i.year if cob!=0 , vce(cl cob) f(poisson)
preserve
collapse year if e(sample), by(cob)
list cob
restore
